<!DOCTYPE html>
<html>
	<head>
		<title>Ağırlık Sayacı Dağlımları</title>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="X-UA-Compatible" content="IE=edge" />
		<meta name="viewport" content="width=device-width, initial-scale=1">
		<script type="text/javascript" src="jquery-1.10.2.js"></script>
		<script type="text/javascript" src="calculationlib/matrixlib.js"></script>
		<script type="text/javascript" src="calculationlib/ecclib.js"></script>
		<script type="text/javascript" src="calculationlib/polynomial.js"></script>
		<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.6/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
		<!--<script type="text/javascript" src="MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>-->
		<script type="text/x-mathjax-config">
			MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
			MathJax.Localization.setLocale("tr");
		</script>
		<script>
			var AddFormula = function(container, name, tex) {
				var containerSelector = $('#' + container);
				if ($('#' + name).length == 0)
					containerSelector.append("<div id='" + name + "' style='text-align:center; visibility: visible; padding:10;'>");
				else $('#' + name).html("");

				$('#' + name).append($('<script type="math/tex">').text("\\displaystyle{"+tex+"}"));
				MathJax.Hub.Queue(["Typeset",MathJax.Hub]);
			}
			var CreateTable = function(div, name, colCount, rowCount) {
				var table = "<table id=" + name + ">";
				for (var i = 0; i < rowCount; i++) {
					table += "<tr id = tr_" + name + "_" + i + ">";
					for (var j = 0; j < colCount; j++) {
						table += "<td id=td_" + name + "_" + j + "_" + i + "> </td>";
					}
					table += "</tr>";
				}
				table += "</table>";
				$("#" + div).append(table);
			}
		</script>
		<style>
		
		#result td {
			text-align: center;
			padding: 2px ;
			border: 1px black solid;
		}
		
		table[id=result] {
			border-collapse: collapse;
			margin-left:auto; 
			margin-right:auto;
			margin-top: 15px;
		}
		
		
		#result2 td {
			text-align: center;
			padding: 2px ;
			border: 1px black solid;
		}
		
		table[id=result2] {
			border-collapse: collapse;
			margin-left:auto; 
			margin-right:auto;
			margin-top: 15px;
		}
		
		</style>
	
	</head>
	<body>
		<h3>Ağırlık Sayacı Dağılımı</h3>

		<table>
		<tr> <td><b>k:</b></td> <td><input type="text" id="txtK" value="2"/></td> </tr>
		<tr> <td><b>n:</b></td> <td><input type="text" id="txtN" value="3"/></td> </tr>
		
		<tr> <td></td> <td><input type="button" id="btnCalculate" value="Ağırlık Sayaçlarının Dağılımı" /></td> </tr>
		</table>
		
		<div id="divResult"></div>
		
		<script type="text/javascript">
			$(document).ready(function () {
				$("input[type='button']").click(function (e) {
					if (e.target.id == "btnCalculate") {
						
						$("#divResult").html("");
						
						var factorial = function(a) { var v = 1; for (var i=1; i <= a; i++) v = v * i; return v; }
						var combination = function(n,k) { return factorial(n) / (factorial(n-k) * factorial(k)); }
						var find_weight = function(vector) { var v = 0; for (var i=0; i < vector.length; i++) if (vector[i]!=0)v++; return v; }
						var find_total = function(vector) { var v = 0; for (var i=0; i < vector.length; i++) v += vector[i]; return v; }
						var k = parseInt($('#txtK').val());
						var n = parseInt($('#txtN').val());
						
						var values = [];
						var limits = [];
						var max = 0;
						for (var i = n; i >= 0; i--) {
							var val = combination(n,i);
							values.push("{" + n + "}\\choose{" + i + "}");
							limits.push(val);
							max = Math.max(val, max);
						}
						
						var coeficients = [1];
						for (var i = 1; i < limits.length; i++) 
							coeficients.push((limits[i-1] + 1) *  coeficients[i-1]);
						var length = (limits[limits.length-1] + 1) * coeficients[coeficients.length-1];
						
						var total = Math.pow(2, k);
						values.push("toplam");
						limits.push(Math.pow(2,n));
						var table = [values, limits];
						
						var convertToDomain = function(value, coeficients) { 
							var result = [];
							for (var i = coeficients.length-1; i >= 0; i--) {
								var d = parseInt(value / coeficients[i]);
								var r = value % coeficients[i];
								result.push(d);
								value = r;
							}
							return result.reverse();
						}
						var convertToInt = function(array, coeficients) {
							var val = 0;
							for (var i = 0; i < coeficients.length; i++) {
								var r = array[i] * coeficients[i];
								val += r;
							}
							return val;
						}
						
						var wegihtsIsOK = [];
						var k = 0;
						for (var i = 0; i < length; i++) {
							var array = convertToDomain(i, coeficients);
							
							var t = find_total(array);	
							if (t == total && array[0] == 1) {
								
								var w = find_weight(array);
								if (w == 2)
									wegihtsIsOK.push(table.length);
								
								array = array.reverse();
								array.push(t);
								table.push(array);
							}
						}
						
						AddFormula("divResult", "count", "Say:" + (table.length - 2));
						
						
						var colCount = values.length;
						var rowCount = table.length;
						CreateTable("divResult", "result", colCount, rowCount);
						for (var i = 0; i < colCount; i++) {
							for (var j = 0; j < rowCount; j++) {
								var cellName = "td_result_" + i + "_"+ j;
								var text = table[j][i];
								AddFormula(cellName, cellName, text);
							}
						}
						
						
						$('#tr_result_0').children('td, th').css('background-color','#c2c2a3');
						$('#tr_result_1').children('td, th').css('background-color','#c2c2a3');
						for (var i = 0; i < wegihtsIsOK.length; i++) {
							var rowName = "tr_result_" + wegihtsIsOK[i];
							//$('#' + rowName).children('td, th').css('background-color','green');
						}
						
						return;
						
						var formulaText = "\\begin{eqnarray*}";
						formulaText += "n &=& \\frac{q^r-1}{q-1} \\\\";
						formulaText += "k &=& n - r";
						formulaText += "\\end{eqnarray*}";
						AddFormula("divResult", "formula", formulaText);
						
						
						
						var values = [];
						var qmin = Math.min(q1, q2);
						var qmax = Math.max(q1, q2);
						var rmin = Math.min(r1, r2);
						var rmax = Math.max(r1, r2);
						
						
						
						var col = [];
						values.push(col);
						col.push("");
						for (var r = rmin; r <= rmax; r++) {
							col.push("r=" + r);
						}
						
						for (var q = qmin; q <= qmax; q++) {
							var col = [];
							values.push(col);
							col.push("q=" + q);
							for (var r = rmin; r <= rmax; r++) {
								var n = (Math.pow(q, r) - 1) / (q - 1);
								var k = n - r;
								var text = "[" + n + "," + k + "]";
								
								//if(Math.pow(q,k) * (combination(n,0) + combination(n,1) * (q-1)) == Math.pow(q,n))
								//	text += "\\\\M";
								//else text += "\\\\MD";
								col.push(text);
							}
						}
						
						
						
						var colCount = qmax - qmin + 2;
						var rowCount = rmax - rmin + 2;
						CreateTable("divResult", "result", colCount, rowCount);
						for (var i = 0; i < colCount; i++) {
							for (var j = 0; j < rowCount; j++){
								var cellName = "td_result_" + i + "_"+ j;
								var text = values[i][j];
								AddFormula(cellName, cellName, text);
							}
						}
						
					}
				});
			});
		</script>

	</body>
</html>
